import * as mc from "@minecraft/server";

mc.world.afterEvents.playerPlaceBlock.subscribe( data => {
    const block = data.block;
    const loc = block.location;
    const player = data.player;
    if (block && (block.typeId == "bg:fairy_blossom" || block.typeId == "bg:purpureum")) {
    player.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z} run function floralf_top`);
    }
});

mc.world.beforeEvents.worldInitialize.subscribe( initEvent =>{
    initEvent.blockTypeRegistry.registerCustomComponent('block:blossom_change', {
     onTick(data){
       const block = data.block;
       const loc = block.location;
       const state = block.permutation.getState('block:blossom');
       var ticks = mc.world.getTimeOfDay();

       if (ticks > 24000) {
          ticks = ticks % 24000;
       }
       if (ticks > 0 && ticks < 8200) {
       if (state != 0) {
          block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run setblock ~~~ ${block.typeId} ["block:blossom" = 0]`);
          return;
       }} else if (ticks > 8200 && ticks < 12786) {
       if (state != 1) {
          block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run setblock ~~~ ${block.typeId} ["block:blossom" = 1]`);
          return;
       }} else if (ticks > 12786 && ticks < 13670) {
       if (state != 2) {
          block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run setblock ~~~ ${block.typeId} ["block:blossom" = 2]`);
          return;
       }} else if (ticks > 13670 && ticks < 22331) {
       if (state != 3) {
          block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run setblock ~~~ ${block.typeId} ["block:blossom" = 3]`);
          return;
       }} else if (ticks > 22331 && ticks < 23300) {
       if (state != 2) {
          block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run setblock ~~~ ${block.typeId} ["block:blossom" = 2]`);
          return;
       }} else if (ticks > 23300 && ticks < 23900) {
       if (state != 1) {
          block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run setblock ~~~ ${block.typeId} ["block:blossom" = 1]`);
          return;
       }} else if (ticks > 23900 && ticks < 24000) {
       if (state != 0) {
          block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run setblock ~~~ ${block.typeId} ["block:blossom" = 0]`);
          return;
          }
       }}
    });
    initEvent.blockTypeRegistry.registerCustomComponent('block:flower_top', {
     onTick(data){
       const block = data.block;
       const loc = block.location;
       block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run function floralf_top2`);
      }
   });
})

mc.world.beforeEvents.playerInteractWithBlock.subscribe( data => {
    const block = data.block;
    const loc = block.location;
    const player = data.player;
    const equip = player.getComponent('equippable');
    const flowers = [
    "bg:black_hyacinth",
    "bg:blue_hyacinth",
    "bg:chocolate_cosmos",
    "bg:dawn_orchid",
    "bg:foxnip",
    "bg:frosted_foxnip",
    "bg:gem_of_the_jungle",
    "bg:lunula",
    "bg:morning_orchid",
    "bg:muscari",
    "bg:orange_cosmos",
    "bg:pink_cosmos",
    "bg:pink_hyacinth",
    "bg:pulse_petal",
    "bg:rose",
    "bg:scilla",
    "bg:stonette",
    "bg:sunset_orchid",
    "bg:twilight_orchid",
    "bg:white_cosmos",
    "bg:yellow_hyacinth"
    ];
    let item = data.itemStack;

    if (!item) {
       switch (block.typeId) {
         case "bg:black_hyacinth_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:black_hyacinth_item`);
           break;
         case "bg:blue_hyacinth_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:blue_hyacinth_item`);
           break;
         case "bg:chocolate_cosmos_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:chocolate_cosmos_item`);
           break;
         case "bg:dawn_orchid_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:dawn_orchid_item`);
           break;
         case "bg:foxnip_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:foxnip_item`);
           break;
         case "bg:frosted_foxnip_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:frosted_foxnip_item`);
           break;
         case "bg:gem_of_the_jungle_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:gem_of_the_jungle_item`);
           break;
         case "bg:lunula_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:lunula_item`);
           break;
         case "bg:morning_orchid_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:morning_orchid_item`);
           break;
         case "bg:muscari_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:muscari_item`);
           break;
         case "bg:orange_cosmos_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:orange_cosmos_item`);
           break;
         case "bg:pink_cosmos_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:pink_cosmos_item`);
           break;
         case "bg:pink_hyacinth_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:pink_hyacinth_item`);
           break;
         case "bg:pulse_petal_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:pulse_petal_item`);
           break;
         case "bg:rose_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:rose_item`);
           break;
         case "bg:scilla_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:scilla_item`);
           break;
         case "bg:stonette_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:stonette_item`);
           break;
         case "bg:sunset_orchid_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:sunset_orchid_item`);
           break;
         case "bg:twilight_orchid_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:twilight_orchid_item`);
           break;
         case "bg:white_cosmos_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:white_cosmos_item`);
           break;
         case "bg:yellow_hyacinth_potted":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} flower_pot`);
           player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 bg:yellow_hyacinth_item`);
           break;
        }
    return;
    } else if (item.typeId == "minecraft:bone_meal") {
    if (block.typeId == "bg:fairy_blossom" || block.typeId == "bg:fairy_blossom_top") {
       block.dimension.runCommandAsync(`loot spawn ${loc.x} ${loc.y} ${loc.z} loot "blocks/flowers/fairy_blossom"`);
       block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run particle minecraft:crop_growth_emitter ~~~`);
       block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run playsound item.bone_meal.use @a ~~~`);
       player.runCommandAsync(`clear @s bone_meal 0 1`);

    } else if (block.typeId == "bg:purpureum" || block.typeId == "bg:purpureum_top") {
       block.dimension.runCommandAsync(`loot spawn ${loc.x} ${loc.y} ${loc.z} loot "blocks/flowers/purpureum"`);
       block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run particle minecraft:crop_growth_emitter ~~~`);
       block.dimension.runCommandAsync(`execute positioned ${loc.x} ${loc.y} ${loc.z} run playsound item.bone_meal.use @a ~~~`);
    player.runCommandAsync(`clear @s bone_meal 0 1`);

    } else if (block.typeId == "bg:thorn_blossom_bottom") {
      const locy = loc.y - 1;
       player.runCommandAsync(`execute if block ${loc.x} ${locy} ${loc.z} air run clear @s bone_meal 0 1`);
       block.dimension.runCommandAsync(`execute if block ${loc.x} ${locy} ${loc.z} air positioned ${loc.x} ${loc.y} ${loc.z} run particle minecraft:crop_growth_emitter ~~~`);
       block.dimension.runCommandAsync(`execute if block ${loc.x} ${locy} ${loc.z} air positioned ${loc.x} ${loc.y} ${loc.z} run playsound item.bone_meal.use @a ~~~`);
       block.dimension.runCommandAsync(`setblock ${loc.x} ${locy} ${loc.z} bg:thorn_blossom_bottom keep`);

    } else if (flowers.includes(block.typeId)) {
       player.runCommandAsync(`execute as @s positioned ${loc.x} ${loc.y} ${loc.z} run function floralf_generate`);
    }} else if (block.typeId == "minecraft:flower_pot" && !player.isSneaking) {
       switch (item.typeId) {
         case "bg:black_hyacinth_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:black_hyacinth_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:blue_hyacinth_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:blue_hyacinth_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:chocolate_cosmos_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:chocolate_cosmos_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:dawn_orchid_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:dawn_orchid_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:foxnip_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:foxnip_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:frosted_foxnip_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:frosted_foxnip_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:gem_of_the_jungle_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:gem_of_the_jungle_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:lunula_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:lunula_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:morning_orchid_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:morning_orchid_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:muscari_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:muscari_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:orange_cosmos_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:orange_cosmos_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:pink_cosmos_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:pink_cosmos_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:pink_hyacinth_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:pink_hyacinth_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:pulse_petal_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:pulse_petal_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:rose_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:rose_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:scilla_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:scilla_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:stonette_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:stonette_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:sunset_orchid_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:sunset_orchid_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:twilight_orchid_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:twilight_orchid_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:white_cosmos_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:white_cosmos_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
         case "bg:yellow_hyacinth_item":
           block.dimension.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} bg:yellow_hyacinth_potted`);
           player.runCommandAsync(`clear @s ${item.typeId} 0 1`);
           break;
    }}
});